#ifndef SIC45x_Header
#define SIC45x_Header

#include <I2C_8Bit.h>

// IC addresses - Address pin is low
#define SIC45X_PMB_ADDR0_0_845				0b0010000
#define SIC45X_PMB_ADDR0_1_3				0b0010001
#define SIC45X_PMB_ADDR0_1_78				0b0010010
#define SIC45X_PMB_ADDR0_2_32				0b0010011
#define SIC45X_PMB_ADDR0_2_87				0b0010100
#define SIC45X_PMB_ADDR0_3_48				0b0010101
#define SIC45X_PMB_ADDR0_4_12				0b0010110
#define SIC45X_PMB_ADDR0_4_75				0b0010111
#define SIC45X_PMB_ADDR0_5_49				0b0011000
#define SIC45X_PMB_ADDR0_6_19				0b0011001
#define SIC45X_PMB_ADDR0_6_98				0b0011010
#define SIC45X_PMB_ADDR0_7_87				0b0011011
#define SIC45X_PMB_ADDR0_8_87				0b0011100
#define SIC45X_PMB_ADDR0_10_0				0b0011101
#define SIC45X_PMB_ADDR0_11_0				0b0011110

// IC addresses - Address pin is high
#define SIC45X_PMB_ADDR1_0_845				0b1010000
#define SIC45X_PMB_ADDR1_1_3				0b1010001
#define SIC45X_PMB_ADDR1_1_78				0b1010010
#define SIC45X_PMB_ADDR1_2_32				0b1010011
#define SIC45X_PMB_ADDR1_2_87				0b1010100
#define SIC45X_PMB_ADDR1_3_48				0b1010101
#define SIC45X_PMB_ADDR1_4_12				0b1010110
#define SIC45X_PMB_ADDR1_4_75				0b1010111
#define SIC45X_PMB_ADDR1_5_49				0b1011000
#define SIC45X_PMB_ADDR1_6_19				0b1011001
#define SIC45X_PMB_ADDR1_6_98				0b1011010
#define SIC45X_PMB_ADDR1_7_87				0b1011011
#define SIC45X_PMB_ADDR1_8_87				0b1011100
#define SIC45X_PMB_ADDR1_10_0				0b1011101
#define SIC45X_PMB_ADDR1_11_0				0b1011110

// Register addresses
#define SIC45X_OPERATION_ADDR				0x01
#define SIC45X_ON_OFF_CONF_ADDR				0x02
#define SIC45X_CLEAR_FAULTS_ADDR			0x03
#define SIC45X_WRITE_PROTECT_ADDR			0x10
#define SIC45X_STORE_USER_ALL_ADDR			0x15
#define SIC45X_RESTORE_USER_ALL_ADDR		0x16
#define SIC45X_CAPABILITY_ADDR				0x19
#define SIC45X_SMBALERT_MASK_ADDR			0x1B
#define SIC45X_VOUT_MODE_ADDR				0x20
#define SIC45X_VOUT_COMMAND_ADDR			0x21
#define SIC45X_VOUT_TRIM_ADDR				0x22
#define SIC45X_VOUT_MAX_ADDR				0x24
#define SIC45X_VOUT_MARGIN_HIGH_ADDR		0x25
#define SIC45X_VOUT_MARGIN_LOW_ADDR			0x26
#define SIC45X_VOUT_TRANSITION_RATE_ADDR	0x27
#define SIC45X_VOUT_SCALE_LOOP_ADDR			0x29
#define SIC45X_FREQUENCY_SWITCH_ADDR		0x33
#define SIC45X_VIN_ON_ADDR					0x35
#define SIC45X_VIN_OFF_ADDR					0x36
#define SIC45X_INTERLEAVE_ADDR				0x37
#define SIC45X_VOUT_OV_FAULT_LIMIT_ADDR		0x40
#define SIC45X_VOUT_OV_FAULT_RESPONSE_ADDR	0x41
#define SIC45X_VOUT_OV_WARN_LIMIT_ADDR		0x42
#define SIC45X_VOUT_UV_WARN_LIMIT_ADDR		0x43
#define SIC45X_VOUT_UV_FAULT_LIMIT_ADDR		0x44
#define SIC45X_VOUT_UV_FAULT_RESPONSE_ADDR	0x45
#define SIC45X_IOUT_OC_FAULT_LIMIT_ADDR		0x46
#define SIC45X_IOUT_OC_FAULT_RESPONSE_ADDR	0x47
#define SIC45X_IOUT_OC_WARN_LIMIT_ADDR		0x4A
#define SIC45X_OT_FAULT_LIMIT_ADDR			0x4F
#define SIC45X_OT_FAULT_RESPONSE_ADDR		0x50
#define SIC45X_OT_WARN_LIMIT_ADDR			0x51
#define SIC45X_VIN_OV_FAULT_LIMIT_ADDR		0x55
#define SIC45X_VIN_OV_FAULT_RESPONSE_ADDR	0x56
#define SIC45X_VIN_UV_WARN_LIMIT_ADDR		0x58
#define SIC45X_IIN_OC_WARN_LIMIT_ADDR		0x5D
#define SIC45X_POWER_GOOD_ON_ADDR			0x5E
#define SIC45X_POWER_GOOD_OFF_ADDR			0x5F
#define SIC45X_TON_DELAY_ADDR				0x60
#define SIC45X_TON_RISE_ADDR				0x61
#define SIC45X_TON_MAX_FAULT_LIMIT_ADDR		0x62
#define SIC45X_TON_MAX_FAULT_RESPONSE_ADDR	0x63
#define SIC45X_TOFF_DELAY_ADDR				0x64
#define SIC45X_TOFF_FALL_ADDR				0x65
#define SIC45X_TOFF_MAX_WARN_LIMIT_ADDR		0x66
#define SIC45X_STATUS_BYTE_ADDR				0x78
#define SIC45X_STATUS_WORD_ADDR				0x79
#define SIC45X_STATUS_VOUT_ADDR				0x7A
#define SIC45X_STATUS_IOUT_ADDR				0x7B
#define SIC45X_STATUS_INPUT_ADDR			0x7C
#define SIC45X_STATUS_TEMPERATURE_ADDR		0x7D
#define SIC45X_STATUS_CML_ADDR				0x7E
#define SIC45X_STATUS_MFR_SPECIFIC_ADDR		0x80
#define SIC45X_READ_VIN_ADDR				0x88
#define SIC45X_READ_IIN_ADDR				0x89
#define SIC45X_READ_VOUT_ADDR				0x8B
#define SIC45X_READ_IOUT_ADDR				0x8C
#define SIC45X_READ_TEMPERATURE_ADDR		0x8D
#define SIC45X_READ_DUTY_CYCLE_ADDR			0x94
#define SIC45X_READ_POUT_ADDR				0x96
#define SIC45X_READ_PIN_ADDR				0x97
#define SIC45X_PMBUS_REVISION_ADDR			0x98
#define SIC45X_MFR_SERIAL_ADDR				0x9E
#define SIC45X_IC_DEVICE_ID_ADDR			0xAD
#define SIC45X_MFR_BASE_ADDRESS_ADDR		0xD7
#define SIC45X_MFR_BASE_ADDRESS_2_ADDR		0xE2

uint8_t SIC45X_readRegister(uint8_t pmbAddr, uint8_t registerAddr);
void SIC45X_writeRegister(uint8_t pmbAddr, uint8_t registerAddr, uint8_t data);
uint8_t SIC45X_readFlag(uint8_t pmbAddr, uint8_t registerAddr, uint8_t flagPos);
void SIC45X_writeFlag(uint8_t pmbAddr, uint8_t registerAddr, uint8_t flagPos, uint8_t data);

#endif